/*
PRO vector_set,b,n
; generate a vector set, b of size 16x16 data for testing at N=n. for USES
; setting at blkref=1, nn prection mode
; the last 16 data (the 16th vector) chooses default mode
; the k=0 option is chosen when running vector_b1,a,4
; the vector_b1,a,4  to vector_b1,a,n gives n-4+1 vectors, which when added with
; vector_b2,a,n and vector_b3,a,n, and vector_default,a,n, a total of (n-4+1)+3 
; vectors (total n) will be the last n vectors of the 16 vectors. The 
; remaining 16-n vectors are assigned low-entropy options
; if n <= 8, b is char array, otherwise, b is int*2 array. Max. n now set at 15
*/
#include <stdio.h>
main(argc,argv)
int argc;
char *argv[];
{
	unsigned short int *b,*pb;
	unsigned short int a[16];
	unsigned char *c=NULL,*pc;
	int n;
	int i,j,npixs,nout;
    	FILE *fp_out;
	int output_flag;
	void vector_b1(unsigned short int a[16],int n);
	void vector_b2(unsigned short int a[16],int n);
	void vector_b3(unsigned short int a[16],int n);
	void vector_default(unsigned short int a[16],int n);

        if(argc < 3 ) {
          printf("Usage: %s nbits_samp output_flag \n",argv[0]);
          exit(1);
        }
 
        n = atoi(argv[1]);
        output_flag = atoi(argv[2]);

	npixs = 16*(n+12);
        b=(unsigned short int * ) malloc(npixs*sizeof(unsigned short int));

	vector_default(b,n);

	vector_b3(&b[16],n);

	vector_b2(&b[32],n);

	for (i=4; i<=n; i++) vector_b1(&b[(n+3-i)*16],i);

        for (i=n; i<n+12; i++)
          for (j=0; j< 16; j++) b[i*16+j] = 1;

        b[16*n] = 0;

        if( (fp_out = fopen("fileout","wb")) == NULL) {
           printf("Failed to open output file \n");
           exit(1);
           }

	if(output_flag==0) 
	   {
	   printf("Users request to output only 256 elements \n");
	   nout = 256;
	   }
	else
	   {
	   printf("Users request to output all the elements\n");
	   nout = npixs;
	   }

	if(n <= 8 ) {
          c=(unsigned char * ) malloc(npixs*sizeof(unsigned char));
	  pb=b;
	  pc=c;
	  for(i=0; i<npixs; i++) *pc++ = (unsigned char) *pb++;
	  fwrite(&c[0],sizeof(unsigned char), nout, fp_out);
	}
	else {
	  fwrite(&b[0],sizeof(unsigned short int), nout, fp_out);
	}

	if(output_flag==0)
	{	for(i=0;i<16;++i)
		{ 	for(j=0;j<16;++j) printf("%6d",*(b+i*16+j));
			printf("\n");
		}
	}
	else
	{
		for(i=0; i<n+12; i++) 
		{	for(j=0;j<16;++j) printf("%6d",*(b+i*16+j));
			printf("\n");
		}
	}

	free(b);
	if(c) free(c);
        fclose(fp_out);
}


